/*
 * Copyright ? Matthew Chappee <matthew@orasoft.org>
 *             Paul Flinders <paul@orasoft.org>
 *             Brent Gilmore <brent@orasoft.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "sqlworksig.h"
#include "sqlworksrc.h"

GtkWidget*
sql_create_aboutbox ()
{
  GtkWidget *fixed1;
  GtkWidget *button1;
  GtkWidget *pixmap1;
  char *homedir,icondir[255];
  
  homedir=getenv("HOME");

  sql_aboutwin.sql_aboutbox = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (sql_aboutwin.sql_aboutbox), "sql_aboutwin.sql_aboutbox", sql_aboutwin.sql_aboutbox);
  gtk_window_set_title (GTK_WINDOW (sql_aboutwin.sql_aboutbox), "About");
  gtk_window_set_policy (GTK_WINDOW (sql_aboutwin.sql_aboutbox), TRUE, TRUE, FALSE);

  fixed1 = gtk_fixed_new ();
  gtk_object_set_data (GTK_OBJECT (sql_aboutwin.sql_aboutbox), "fixed1", fixed1);
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (sql_aboutwin.sql_aboutbox), fixed1);

  sprintf(icondir,"%s/login.xpm",sql_ginfo.iconpath);

  pixmap1 = sql_create_pixmap (sql_aboutwin.sql_aboutbox, icondir);
  if (pixmap1 == NULL){
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");
  }else{
    gtk_widget_ref (pixmap1);
    gtk_object_set_data_full (GTK_OBJECT (sql_aboutwin.sql_aboutbox), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (pixmap1);
    gtk_fixed_put (GTK_FIXED (fixed1), pixmap1, 0,10);
    gtk_widget_set_uposition (pixmap1, 0,10);
    gtk_widget_set_usize (pixmap1, 384, 48);
  }


  sql_aboutwin.sql_text3 = gtk_text_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_aboutwin.sql_aboutbox), "sql_aboutwin.sql_text3", sql_aboutwin.sql_text3);
  gtk_widget_show (sql_aboutwin.sql_text3);
  gtk_fixed_put (GTK_FIXED (fixed1), sql_aboutwin.sql_text3, 0, 70);
  gtk_widget_set_uposition (sql_aboutwin.sql_text3, 0, 70);
  gtk_widget_set_usize (sql_aboutwin.sql_text3, 384, 272);
  gtk_widget_realize (sql_aboutwin.sql_text3);

  button1 = gtk_button_new_with_label ("Close");
  gtk_object_set_data (GTK_OBJECT (sql_aboutwin.sql_aboutbox), "button1", button1);
  gtk_widget_show (button1);
  gtk_fixed_put (GTK_FIXED (fixed1), button1, 172,350);
  gtk_widget_set_uposition (button1, 172, 350);
  gtk_widget_set_usize (button1, 44, 19);
  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (sql_destroy_about),
                      NULL);

  return sql_aboutwin.sql_aboutbox;
}

