/*
 * Copyright ? Matthew Chappee <matthew@orasoft.org>
 *             Paul Flinders <paul@orasoft.org>
 *             Brent Gilmore <brent@orasoft.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "sqlworksig.h"
#include "sqlworksrc.h"

GtkWidget*
sql_create_window5 (int a)
{
  GtkWidget *vbox1;
  GtkWidget *label15;
  GtkWidget *fixed1;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *button17;
  GtkWidget *button18;
  char *homedir,icondir[255];

  homedir=getenv("HOME");

  sql_configwin.sql_window5 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (sql_configwin.sql_window5), "sql_configwin.sql_window5", sql_configwin.sql_window5);
  gtk_window_set_title (GTK_WINDOW (sql_configwin.sql_window5), "Change Option");

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_widget_set_usize (vbox1, 388, 88);
  gtk_object_set_data_full (GTK_OBJECT (sql_configwin.sql_window5), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (sql_configwin.sql_window5), vbox1);

if(a){
  label15 = gtk_label_new ("Delimiter");
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (sql_configwin.sql_window5), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_box_pack_start (GTK_BOX (vbox1), label15, FALSE, FALSE, 0);
}else{
  label15 = gtk_label_new ("Max Buffer (in bytes)");
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (sql_configwin.sql_window5), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_box_pack_start (GTK_BOX (vbox1), label15, FALSE, FALSE, 0);
}

  sql_configwin.sql_entry10 = gtk_entry_new ();
  gtk_widget_ref (sql_configwin.sql_entry10);
  gtk_object_set_data_full (GTK_OBJECT (sql_configwin.sql_window5), "sql_configwin.sql_entry10", sql_configwin.sql_entry10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sql_configwin.sql_entry10);
  gtk_box_pack_start (GTK_BOX (vbox1), sql_configwin.sql_entry10, FALSE, FALSE, 0);

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (sql_configwin.sql_window5), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_box_pack_start (GTK_BOX (vbox1), fixed1, TRUE, TRUE, 0);

  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar1);
  gtk_object_set_data_full (GTK_OBJECT (sql_configwin.sql_window5), "toolbar1", toolbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar1);
  gtk_fixed_put (GTK_FIXED (fixed1), toolbar1, 288, 16);
  gtk_widget_set_uposition (toolbar1, 288, 16);
  gtk_widget_set_usize (toolbar1, 32, 16);

  sprintf(icondir,"%s/quit.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_configwin.sql_window5, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");

  button17 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Cancel",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button17);
  gtk_object_set_data_full (GTK_OBJECT (sql_configwin.sql_window5), "button17", button17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button17);

  sprintf(icondir,"%s/submit.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_configwin.sql_window5, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");

  button18 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Set",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button18);
  gtk_object_set_data_full (GTK_OBJECT (sql_configwin.sql_window5), "button18", button18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button18);

  gtk_signal_connect (GTK_OBJECT (button17), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button17_clicked),
                      NULL);
if(a){		      
  gtk_signal_connect (GTK_OBJECT (button18), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button18a_clicked),
                      NULL);
}else{
  gtk_signal_connect (GTK_OBJECT (button18), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button18b_clicked),
                      NULL);
}

  return sql_configwin.sql_window5;
}


