/*
 * Copyright ? Matthew Chappee <matthew@orasoft.org>
 *             Paul Flinders <paul@orasoft.org>
 *             Brent Gilmore <brent@orasoft.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "sqlworksig.h"
#include "sqlworksrc.h"

GtkWidget*
sql_create_window4 ()
{
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *scrolledwindow4;
  GtkWidget *label1;
  GtkWidget *text6;
  GtkWidget *fixed1;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *button15;
  GtkWidget *button16;
  char *homedir,icondir[255];
  
  homedir=getenv("HOME");

  sql_exportwin.sql_window4 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (sql_exportwin.sql_window4), "sql_exportwin.sql_window4", sql_exportwin.sql_window4);
  gtk_window_set_title (GTK_WINDOW (sql_exportwin.sql_window4), "Export");

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_usize (vbox1, 401, 188);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (sql_exportwin.sql_window4), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (sql_exportwin.sql_window4), vbox1);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (sql_exportwin.sql_window4), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (sql_exportwin.sql_window4), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (hbox1), scrolledwindow4, TRUE, TRUE, 0);

  sql_exportwin.sql_clist3 = gtk_clist_new (2);
  gtk_widget_ref (sql_exportwin.sql_clist3);
  gtk_object_set_data_full (GTK_OBJECT (sql_exportwin.sql_window4), "sql_exportwin.sql_clist3", sql_exportwin.sql_clist3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sql_exportwin.sql_clist3);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), sql_exportwin.sql_clist3);
  gtk_clist_set_column_width (GTK_CLIST (sql_exportwin.sql_clist3), 0, 5);
  gtk_clist_set_column_width (GTK_CLIST (sql_exportwin.sql_clist3), 1, 80);
  gtk_clist_column_titles_hide (GTK_CLIST (sql_exportwin.sql_clist3));

  label1 = gtk_label_new ("label1");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (sql_exportwin.sql_window4), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_clist_set_column_widget (GTK_CLIST (sql_exportwin.sql_clist3), 0, label1);

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (sql_exportwin.sql_window4), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_box_pack_start (GTK_BOX (vbox1), fixed1, TRUE, TRUE, 0);

  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar1);
  gtk_object_set_data_full (GTK_OBJECT (sql_exportwin.sql_window4), "toolbar1", toolbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar1);
  gtk_fixed_put (GTK_FIXED (fixed1), toolbar1, 296, 24);
  gtk_widget_set_uposition (toolbar1, 296, 24);
  gtk_widget_set_usize (toolbar1, 32, 16);

  sprintf(icondir,"%s/quit.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_exportwin.sql_window4, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");

  button15 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Cancel",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button15);
  gtk_object_set_data_full (GTK_OBJECT (sql_exportwin.sql_window4), "button15", button15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button15);

  sprintf(icondir,"%s/save.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_exportwin.sql_window4, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");

  button16 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Export",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button16);
  gtk_object_set_data_full (GTK_OBJECT (sql_exportwin.sql_window4), "button16", button16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button16);

  gtk_signal_connect (GTK_OBJECT (sql_exportwin.sql_clist3), "select_row",
                      GTK_SIGNAL_FUNC (sql_on_clist3_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button15), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button15_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button16), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button16_clicked),
                      NULL);

  return sql_exportwin.sql_window4;
}

