/*
 * Copyright ? Matthew Chappee <matthew@orasoft.org>
 *             Paul Flinders <paul@orasoft.org>
 *             Brent Gilmore <brent@orasoft.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <strings.h>
#include "sqlworksrc.h"
#include "sqlworksig.h"

char *sse(char *in)  //Strip spaces from end of string
{
  int i;

  i=strlen(in)-1;
  while(in[i]==' '&&i>-1)i--;
  in[i+1]=0;
  return in;
}


char *ssb(char *in)  //Strip spaces from beginning of string
{
  int i,len;

  i=0;
  len=strlen(in);
  while(in[i]==' '&&i<len)i++;
  memmove(in,in+i,len-i);
  in[len-i]=0;
  return in;
}        

char *nosemi(char *in)  //Strip semis from end of string
{
  int i;

  i=strlen(in)-1;
  while(in[i]==';'&&i>-1)i--;
  in[i+1]=0;
  return in;
}

char *nocrlfe(char *in)  //Strip \r\n from end of string
{
  int i,len;

  i=strlen(in)-1;
  while(in[i]=='\r' || in[i]=='\n' &&i>-1)i--;
  in[i+1]=0;
  
  return in;
}

char *nocrlfb(char *in)  //Strip \r\n from end of string
{
  int i,len;
  
  i=0;
  len=strlen(in);
  while(in[i]=='\r' || in[i]=='\n' &&i<len)i++;
  memmove(in,in+i,len-i);
  in[len-i]=0;
  
  return in;
}


/* Revised by Adrian Miranda for egcs/Solaris */
char *strupr(char *p)
{
char *s;

s=p;
while(*p){
  *p=toupper(*p);
  ++p;
}

return s;

}

char *rc_getval(char *tag,char *rcfile)
{
FILE *stream;
char buf[255];
static char tagval[255];

  if(rcfile){
    stream=fopen(rcfile,"r");
  }else
    stream=fopen(sql_ginfo.regfile,"r");

  if(!stream)
    return NULL;
  
  while(fgets(buf,255,stream)!=NULL){
    if(strstr(buf,tag)){
      strncpy(tagval,buf+strlen(tag),255);
      if(strlen(tagval) < 2){
        return NULL;
      }else
        strtok(tagval,"\r\n");
	
      fclose(stream);
      return tagval;
    }
  
  }

  fclose(stream);
  return NULL;

}

/* Donated by Wayne Hoxsie (wayne@hoxnet.com) */
int rc_changeval(char *tag,char *tagval)
{
  FILE *f,*g;
  char buf[256],*homedir;
  char tmpname[255],newtag[255];
  int a=0;

  sprintf(newtag,"%s%s\n",tag,tagval);

  f=fopen(sql_ginfo.regfile,"r");
  
  /* tmpnam bugfix by Jacques Cerba <Jacques.Cerba@grenoble.sema.fr> */
  homedir=getenv("HOME");
  sprintf(tmpname,"%s/.oralinux/~sqlworkrc.reg",homedir);
  g=fopen(tmpname,"w");
  if(f==NULL||g==NULL){
    perror("File IO error");
    return 0;
  }
  while(fgets(buf,256,f)!=NULL){
    if(strstr(buf,tag)){
      fputs(newtag,g);
      a=1;
    }else{
      fputs(buf,g);
    }
  }
  
  if(a==0)
    fputs(newtag,g);
    
  fclose(f);
  fclose(g);
  unlink(sql_ginfo.regfile);
  rename(tmpname,sql_ginfo.regfile);
  return 1;

}










