/*
 * Copyright ? Matthew Chappee <matthew@orasoft.org>
 *             Paul Flinders <paul@orasoft.org>
 *             Brent Gilmore <brent@orasoft.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "sqlworksig.h"
#include "sqlworksrc.h"

GtkWidget*
sql_create_login ()
{
  GtkWidget *fixed1;
  GtkWidget *pixmap1;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *toolbar2;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  char *homedir,icondir[255];
  
  homedir=getenv("HOME");
  
  sql_loginwin.sql_login = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "sql_loginwin.sql_login", sql_loginwin.sql_login);
  gtk_signal_connect (GTK_OBJECT (sql_loginwin.sql_login), "key_press_event",
                      GTK_SIGNAL_FUNC (sql_on_login_key_press_event),
                      NULL);
  gtk_window_set_title (GTK_WINDOW (sql_loginwin.sql_login), "Oracle Login");
  gtk_window_set_policy (GTK_WINDOW (sql_loginwin.sql_login), TRUE, TRUE, FALSE);

  fixed1 = gtk_fixed_new ();
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "fixed1", fixed1);
  gtk_widget_set_usize (fixed1, 398, 264);
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (sql_loginwin.sql_login), fixed1);

  sql_loginwin.sql_username_entry = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "sql_loginwin.sql_username_entry", sql_loginwin.sql_username_entry);
  gtk_widget_show (sql_loginwin.sql_username_entry);
  gtk_fixed_put (GTK_FIXED (fixed1), sql_loginwin.sql_username_entry, 56, 88);
  gtk_widget_set_uposition (sql_loginwin.sql_username_entry, 56, 88);
  gtk_widget_set_usize (sql_loginwin.sql_username_entry, 280, 24);
  gtk_widget_grab_focus (sql_loginwin.sql_username_entry);
  GTK_WIDGET_SET_FLAGS (sql_loginwin.sql_username_entry, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (sql_loginwin.sql_username_entry);

  if(strncmp(sql_ginfo.globallogin,"none",4)!=0){  
     gtk_entry_set_text(GTK_ENTRY(sql_loginwin.sql_username_entry),sql_ginfo.globallogin);
  }

  sql_loginwin.sql_password_entry = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "sql_loginwin.sql_password_entry", sql_loginwin.sql_password_entry);
  gtk_widget_show (sql_loginwin.sql_password_entry);
  gtk_fixed_put (GTK_FIXED (fixed1), sql_loginwin.sql_password_entry, 56, 128);
  gtk_widget_set_uposition (sql_loginwin.sql_password_entry, 56, 128);
  gtk_widget_set_usize (sql_loginwin.sql_password_entry, 280, 24);
  GTK_WIDGET_SET_FLAGS (sql_loginwin.sql_password_entry, GTK_CAN_DEFAULT);
  gtk_entry_set_visibility (GTK_ENTRY (sql_loginwin.sql_password_entry), FALSE);

  sql_loginwin.sql_tns_entry = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "sql_loginwin.sql_tns_entry", sql_loginwin.sql_tns_entry);
  gtk_widget_show (sql_loginwin.sql_tns_entry);
  gtk_fixed_put (GTK_FIXED (fixed1), sql_loginwin.sql_tns_entry, 56, 168);
  gtk_widget_set_uposition (sql_loginwin.sql_tns_entry, 56, 168);
  gtk_widget_set_usize (sql_loginwin.sql_tns_entry, 280, 24);
  GTK_WIDGET_SET_FLAGS (sql_loginwin.sql_tns_entry, GTK_CAN_DEFAULT);

  sprintf(icondir,"%s/login.xpm",sql_ginfo.iconpath);

  pixmap1 = sql_create_pixmap (sql_loginwin.sql_login, icondir);
  if (pixmap1 == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.\n");
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "pixmap1", pixmap1);
  gtk_widget_show (pixmap1);
  gtk_fixed_put (GTK_FIXED (fixed1), pixmap1, 192, 32);
  gtk_widget_set_uposition (pixmap1, 192, 32);
  gtk_widget_set_usize (pixmap1, 21, 21);

  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "toolbar1", toolbar1);
  gtk_widget_show (toolbar1);
  gtk_fixed_put (GTK_FIXED (fixed1), toolbar1, 56, 224);
  gtk_widget_set_uposition (toolbar1, 56, 224);
  gtk_widget_set_usize (toolbar1, 32, 16);

  sprintf(icondir,"%s/quit-mini.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_loginwin.sql_login, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.\n");
    sql_loginwin.sql_login_cancel = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Cancel",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "sql_loginwin.sql_login_cancel", sql_loginwin.sql_login_cancel);
  gtk_widget_show (sql_loginwin.sql_login_cancel);
  gtk_signal_connect (GTK_OBJECT (sql_loginwin.sql_login_cancel), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_login_cancel_clicked),
                      NULL);

  toolbar2 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "toolbar2", toolbar2);
  gtk_widget_show (toolbar2);
  gtk_fixed_put (GTK_FIXED (fixed1), toolbar2, 288, 224);
  gtk_widget_set_uposition (toolbar2, 288, 224);
  gtk_widget_set_usize (toolbar2, 32, 16);

  sprintf(icondir,"%s/submit-mini.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_loginwin.sql_login, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.\n");
  sql_loginwin.sql_login_ok = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                " Login ",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "sql_loginwin.sql_login_ok", sql_loginwin.sql_login_ok);
  gtk_widget_show (sql_loginwin.sql_login_ok);
  gtk_signal_connect (GTK_OBJECT (sql_loginwin.sql_login_ok), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_login_ok_clicked),
                      NULL);

  label1 = gtk_label_new ("Username");
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "label1", label1);
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed1), label1, 56, 72);
  gtk_widget_set_uposition (label1, 56, 72);
  gtk_widget_set_usize (label1, 280, 16);

  label2 = gtk_label_new ("Password");
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "label2", label2);
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (fixed1), label2, 56, 112);
  gtk_widget_set_uposition (label2, 56, 112);
  gtk_widget_set_usize (label2, 280, 16);

  label3 = gtk_label_new ("Tnsname");
  gtk_object_set_data (GTK_OBJECT (sql_loginwin.sql_login), "label3", label3);
  gtk_widget_show (label3);
  gtk_fixed_put (GTK_FIXED (fixed1), label3, 56, 152);
  gtk_widget_set_uposition (label3, 56, 152);
  gtk_widget_set_usize (label3, 280, 16);

  return sql_loginwin.sql_login;
}

