/*
 * Copyright ? Matthew Chappee <matthew@orasoft.org>
 *             Paul Flinders <paul@orasoft.org>
 *             Brent Gilmore <brent@orasoft.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "sqlworksig.h"
#include "sqlworksrc.h"

void sql_create_menu()
{
  GtkWidget *File;
  GtkWidget *File_menu;
  GtkWidget *Open;
  GtkWidget *Save_Query;
  GtkWidget *Save_Query_As;
  GtkWidget *separator1;
  GtkWidget *Quit;
  GtkWidget *Options;
  GtkWidget *Options_menu;
  GtkWidget *Save_Connection;
  GtkWidget *Forget_Connection;
  GtkWidget *separator3;
  GtkWidget *Change_Connection;
  GtkWidget *Change_Delimiter;
  GtkWidget *Change_Max_Buffer;
  GtkWidget *Launch;
  GtkWidget *Launch_menu;
  GtkWidget *Bookmarks;
  GtkWidget *Bookmarks_menu;
  GtkWidget *Add_Bookmark;
  GtkWidget *Edit_Bookmark;
  GtkWidget *Help;
  GtkWidget *Help_menu;
  GtkWidget *About_SQLWork;
  GtkWidget *About_OraLinux;
  GtkWidget *discoverymenu[20];
  GtkWidget *view1;
  GtkWidget *view1_menu;
  GtkAccelGroup *view1_menu_accels;
  GtkWidget *text1;
  GtkWidget *icons1;
  GtkWidget *text_and_icons1;
  GtkWidget *Toolbar;
  GtkWidget *toolbar1_menu;
  GtkAccelGroup *toolbar1_menu_accels;
  GSList *__group = NULL;
  char *buf5;
  int a=0;

  File = gtk_menu_item_new_with_label ("File");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "File", File);
  gtk_widget_show (File);
  gtk_container_add (GTK_CONTAINER (sql_mainwin.sql_menubar1), File);

  File_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "File_menu", File_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (File), File_menu);

  Open = gtk_menu_item_new_with_label ("Open Query");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Open", Open);
  gtk_widget_show (Open);
  gtk_container_add (GTK_CONTAINER (File_menu), Open);
  gtk_signal_connect (GTK_OBJECT (Open), "activate",
                      GTK_SIGNAL_FUNC (sql_on_Open_activate),
                      NULL);
  sql_mainwin.sql_accel_group = gtk_accel_group_new ();
  gtk_window_add_accel_group (GTK_WINDOW (sql_mainwin.sql_window1), sql_mainwin.sql_accel_group);
  gtk_widget_add_accelerator (Open, "activate", sql_mainwin.sql_accel_group,
                              GDK_o, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);

  Save_Query = gtk_menu_item_new_with_label ("Save Query");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Save_Query", Save_Query);
  gtk_widget_show (Save_Query);
  gtk_container_add (GTK_CONTAINER (File_menu), Save_Query);
  gtk_signal_connect (GTK_OBJECT (Save_Query), "activate",
                      GTK_SIGNAL_FUNC (sql_on_Save_Query_activate),
                      NULL);
  gtk_widget_add_accelerator (Save_Query, "activate", sql_mainwin.sql_accel_group,
                              GDK_s, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);

  Save_Query_As = gtk_menu_item_new_with_label ("Save Query As");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Save_Query_As", Save_Query_As);
  gtk_widget_show (Save_Query_As);
  gtk_container_add (GTK_CONTAINER (File_menu), Save_Query_As);
  gtk_signal_connect (GTK_OBJECT (Save_Query_As), "activate",
                      GTK_SIGNAL_FUNC (sql_on_Save_Query_As_activate),
                      NULL);
  gtk_widget_add_accelerator (Save_Query_As, "activate", sql_mainwin.sql_accel_group,
                              GDK_a, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);

  separator1 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "separator1", separator1);
  gtk_widget_show (separator1);
  gtk_container_add (GTK_CONTAINER (File_menu), separator1);

  Quit = gtk_menu_item_new_with_label ("Quit");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Quit", Quit);
  gtk_widget_show (Quit);
  gtk_container_add (GTK_CONTAINER (File_menu), Quit);
  gtk_signal_connect (GTK_OBJECT (Quit), "activate",
                      GTK_SIGNAL_FUNC (sql_on_Quit_activate),
                      NULL);
  gtk_widget_add_accelerator (Quit, "activate", sql_mainwin.sql_accel_group,
                              GDK_q, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);

  Options = gtk_menu_item_new_with_label ("Options");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Options", Options);
  gtk_widget_show (Options);
  gtk_container_add (GTK_CONTAINER (sql_mainwin.sql_menubar1), Options);

  Options_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Options_menu", Options_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Options), Options_menu);

  Save_Connection = gtk_menu_item_new_with_label ("Save Connection");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Save_Connection", Save_Connection);
  gtk_widget_show (Save_Connection);
  gtk_container_add (GTK_CONTAINER (Options_menu), Save_Connection);
  gtk_signal_connect (GTK_OBJECT (Save_Connection), "activate",
                      GTK_SIGNAL_FUNC (sql_on_Save_Connection_activate),
                      NULL);
  gtk_widget_add_accelerator (Save_Connection, "activate", sql_mainwin.sql_accel_group,
                              GDK_s, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);

  Forget_Connection = gtk_menu_item_new_with_label ("Forget Connection");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Forget_Connection", Forget_Connection);
  gtk_widget_show (Forget_Connection);
  gtk_container_add (GTK_CONTAINER (Options_menu), Forget_Connection);
  gtk_signal_connect (GTK_OBJECT (Forget_Connection), "activate",
                      GTK_SIGNAL_FUNC (sql_on_Forget_Connection_activate),
                      NULL);
  gtk_widget_add_accelerator (Forget_Connection, "activate", sql_mainwin.sql_accel_group,
                              GDK_f, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);

  separator3 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "separator3", separator3);
  gtk_widget_show (separator3);
  gtk_container_add (GTK_CONTAINER (Options_menu), separator3);

  Change_Connection = gtk_menu_item_new_with_label ("Change Connection");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Change_Connection", Change_Connection);
  gtk_widget_show (Change_Connection);
  gtk_container_add (GTK_CONTAINER (Options_menu), Change_Connection);
  gtk_signal_connect (GTK_OBJECT (Change_Connection), "activate",
                      GTK_SIGNAL_FUNC (sql_on_Change_Connection_activate),
                      NULL);
  gtk_widget_add_accelerator (Change_Connection, "activate", sql_mainwin.sql_accel_group,
                              GDK_c, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);

  Change_Delimiter = gtk_menu_item_new_with_label ("Change Delimiter");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Change_Delimiter", Change_Delimiter);
  gtk_widget_show (Change_Delimiter);
  gtk_container_add (GTK_CONTAINER (Options_menu), Change_Delimiter);
  gtk_signal_connect (GTK_OBJECT (Change_Delimiter), "activate",
                      GTK_SIGNAL_FUNC (sql_on_Change_Delimiter_activate),
                      NULL);

  Change_Max_Buffer = gtk_menu_item_new_with_label ("Change Max Buffer");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Change_Max_Buffer", Change_Max_Buffer);
  gtk_widget_show (Change_Max_Buffer);
  gtk_container_add (GTK_CONTAINER (Options_menu), Change_Max_Buffer);
  gtk_signal_connect (GTK_OBJECT (Change_Max_Buffer), "activate",
                      GTK_SIGNAL_FUNC (sql_on_Change_Max_Buffer_activate),
                      NULL);

/*  Bookmarks = gtk_menu_item_new_with_label ("Bookmarks");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Bookmarks", Bookmarks);
  gtk_widget_show (Bookmarks);
  gtk_container_add (GTK_CONTAINER (sql_mainwin.sql_menubar1), Bookmarks);

  Bookmarks_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Bookmarks_menu", Bookmarks_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Bookmarks), Bookmarks_menu);

  Add_Bookmark = gtk_menu_item_new_with_label ("Add Bookmark");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Add_Bookmark", Add_Bookmark);
  gtk_widget_show (Add_Bookmark);
  gtk_container_add (GTK_CONTAINER (Bookmarks_menu), Add_Bookmark);
  gtk_signal_connect (GTK_OBJECT (Add_Bookmark), "activate",
                      GTK_SIGNAL_FUNC (sql_on_Add_Bookmark_activate),
                      NULL);

  Edit_Bookmark = gtk_menu_item_new_with_label ("Edit Bookmark");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Edit_Bookmark", Edit_Bookmark);
  gtk_widget_show (Edit_Bookmark);
  gtk_container_add (GTK_CONTAINER (Bookmarks_menu), Edit_Bookmark);
  gtk_signal_connect (GTK_OBJECT (Edit_Bookmark), "activate",
                      GTK_SIGNAL_FUNC (sql_on_Edit_Bookmark_activate),
                      NULL);
*/
  Toolbar = gtk_menu_item_new_with_label ("Toolbar");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Toolbar", Toolbar);
  gtk_widget_show (Toolbar);
  gtk_container_add (GTK_CONTAINER (Options_menu), Toolbar);

  toolbar1_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "toolbar1_menu", toolbar1_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Toolbar), toolbar1_menu);

  text1 = gtk_radio_menu_item_new_with_label (__group, "Text");
  __group = gtk_radio_menu_item_group (GTK_RADIO_MENU_ITEM (text1));
  gtk_widget_ref (text1);
  gtk_object_set_data_full (GTK_OBJECT (sql_mainwin.sql_window1), "text1", text1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text1);
  gtk_container_add (GTK_CONTAINER (toolbar1_menu), text1);

  icons1 = gtk_radio_menu_item_new_with_label (__group, "Icons");
  __group = gtk_radio_menu_item_group (GTK_RADIO_MENU_ITEM (icons1));
  gtk_widget_ref (icons1);
  gtk_object_set_data_full (GTK_OBJECT (sql_mainwin.sql_window1), "icons1", icons1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (icons1);
  gtk_container_add (GTK_CONTAINER (toolbar1_menu), icons1);

  text_and_icons1 = gtk_radio_menu_item_new_with_label (__group, "Text and Icons");
  __group = gtk_radio_menu_item_group (GTK_RADIO_MENU_ITEM (text_and_icons1));
  gtk_widget_ref (text_and_icons1);
  gtk_object_set_data_full (GTK_OBJECT (sql_mainwin.sql_window1), "text_and_icons1", text_and_icons1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text_and_icons1);
  gtk_container_add (GTK_CONTAINER (toolbar1_menu), text_and_icons1);

  gtk_signal_connect (GTK_OBJECT (text1), "activate",
                      GTK_SIGNAL_FUNC (sql_on_text1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (icons1), "activate",
                      GTK_SIGNAL_FUNC (sql_on_icons1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (text_and_icons1), "activate",
                      GTK_SIGNAL_FUNC (sql_on_text_and_icons1_activate),
                      NULL);

  buf5=rc_getval("tbstate=",NULL);
  if(buf5!=NULL){
     if(strncmp(buf5,"1",1)==0){
       gtk_toolbar_set_style(GTK_TOOLBAR(sql_mainwin.sql_toolbar1), GTK_TOOLBAR_TEXT);
       gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (text1), TRUE);
     }
     if(strncmp(buf5,"2",1)==0){
       gtk_toolbar_set_style(GTK_TOOLBAR(sql_mainwin.sql_toolbar1), GTK_TOOLBAR_ICONS);
       gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (icons1), TRUE);
     }
     if(strncmp(buf5,"3",1)==0){
       gtk_toolbar_set_style(GTK_TOOLBAR(sql_mainwin.sql_toolbar1), GTK_TOOLBAR_BOTH);
       gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (text_and_icons1), TRUE);
     }
  }else{
     rc_changeval("tbstate=","3");
  }


  Launch = gtk_menu_item_new_with_label ("Launch");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Launch", Launch);
  gtk_widget_show (Launch);
  gtk_container_add (GTK_CONTAINER (Options_menu), Launch);
  gtk_widget_add_accelerator (Launch, "activate", sql_mainwin.sql_accel_group,
                              GDK_l, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);

  Launch_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Launch_menu", Launch_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Launch), Launch_menu);

  sql_discovery();

  while(a != sql_ginfo.totaldisc){
   discoverymenu[a] = gtk_menu_item_new_with_label (sql_disc[a].dname);
   gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), sql_disc[a].dname, discoverymenu[a]);
   gtk_widget_show (discoverymenu[a]);
   gtk_container_add (GTK_CONTAINER (Launch_menu), discoverymenu[a]);
   gtk_signal_connect (GTK_OBJECT (discoverymenu[a]), "activate",
                      GTK_SIGNAL_FUNC (sql_on_Discovery_activate),
                      (gpointer) a);
   a++;
  }

  Help = gtk_menu_item_new_with_label ("Help");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Help", Help);
  gtk_widget_show (Help);
  gtk_container_add (GTK_CONTAINER (sql_mainwin.sql_menubar1), Help);
  gtk_menu_item_right_justify (GTK_MENU_ITEM (Help));

  Help_menu = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "Help_menu", Help_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Help), Help_menu);

  About_SQLWork = gtk_menu_item_new_with_label ("About_SQLWork");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "About_SQLWork", About_SQLWork);
  gtk_widget_show (About_SQLWork);
  gtk_container_add (GTK_CONTAINER (Help_menu), About_SQLWork);
  gtk_signal_connect (GTK_OBJECT (About_SQLWork), "activate",
                      GTK_SIGNAL_FUNC (sql_on_About_SQLWork_activate),
                      NULL);

  About_OraLinux = gtk_menu_item_new_with_label ("About OraLinux");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "About_OraLinux", About_OraLinux);
  gtk_widget_show (About_OraLinux);
  gtk_container_add (GTK_CONTAINER (Help_menu), About_OraLinux);
  gtk_signal_connect (GTK_OBJECT (About_OraLinux), "activate",
                      GTK_SIGNAL_FUNC (sql_on_About_OraLinux_activate),
                      NULL);


}

