/*
 * Copyright ? Matthew Chappee <matthew@orasoft.org>
 *             Paul Flinders <paul@orasoft.org>
 *             Brent Gilmore <brent@orasoft.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "sqlworksig.h"
#include "sqlworksrc.h"

GtkWidget*
sql_create_window3 ()
{
  GtkWidget *vbox1;
  GtkWidget *fixed1;
  GtkWidget *pixmap2;
  GtkWidget *label1;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *button13;
  GtkWidget *button14;
  char *homedir,icondir[255];
  
  homedir=getenv("HOME");

  sql_printwin.sql_window3 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (sql_printwin.sql_window3), "sql_printwin.sql_window3", sql_printwin.sql_window3);
  gtk_window_set_title (GTK_WINDOW (sql_printwin.sql_window3), "Print");
  gtk_window_set_policy (GTK_WINDOW (sql_printwin.sql_window3), TRUE, TRUE, FALSE);
  gtk_signal_connect (GTK_OBJECT (sql_mainwin.sql_window1), "destroy",
                     (GtkSignalFunc) gtk_widget_destroy , NULL);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (sql_printwin.sql_window3), "vbox1", vbox1);
  gtk_widget_set_usize (vbox1, 375, 188);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (sql_printwin.sql_window3), vbox1);

  fixed1 = gtk_fixed_new ();
  gtk_object_set_data (GTK_OBJECT (sql_printwin.sql_window3), "fixed1", fixed1);
  gtk_widget_show (fixed1);
  gtk_box_pack_start (GTK_BOX (vbox1), fixed1, TRUE, TRUE, 0);

  sql_printwin.sql_entry1 = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (sql_printwin.sql_window3), "sql_printwin.sql_entry1", sql_printwin.sql_entry1);
  gtk_widget_show (sql_printwin.sql_entry1);
  gtk_fixed_put (GTK_FIXED (fixed1), sql_printwin.sql_entry1, 16, 48);
  gtk_widget_set_uposition (sql_printwin.sql_entry1, 16, 48);
  gtk_widget_set_usize (sql_printwin.sql_entry1, 232, 24);

  sprintf(icondir,"%s/printer.xpm",sql_ginfo.iconpath);

  pixmap2 = sql_create_pixmap (sql_printwin.sql_window3, icondir);
  if (pixmap2 == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.\n");
  gtk_object_set_data (GTK_OBJECT (sql_printwin.sql_window3), "pixmap2", pixmap2);
  gtk_widget_show (pixmap2);
  gtk_fixed_put (GTK_FIXED (fixed1), pixmap2, 304, 40);
  gtk_widget_set_uposition (pixmap2, 304, 40);
  gtk_widget_set_usize (pixmap2, 21, 21);

  label1 = gtk_label_new ("Printer Command:");
  gtk_object_set_data (GTK_OBJECT (sql_printwin.sql_window3), "label1", label1);
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed1), label1, 8, 24);
  gtk_widget_set_uposition (label1, 8, 24);
  gtk_widget_set_usize (label1, 120, 16);

  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_object_set_data (GTK_OBJECT (sql_printwin.sql_window3), "toolbar1", toolbar1);
  gtk_widget_show (toolbar1);
  gtk_box_pack_start (GTK_BOX (vbox1), toolbar1, FALSE, TRUE, 7);
  gtk_container_border_width (GTK_CONTAINER (toolbar1), 11);
  gtk_toolbar_set_space_size (GTK_TOOLBAR (toolbar1), 0);

  sprintf(icondir,"%s/print.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_printwin.sql_window3, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.\n");
  button13 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Print",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_printwin.sql_window3), "button13", button13);
  gtk_widget_show (button13);
  gtk_container_border_width (GTK_CONTAINER (button13), 6);
  gtk_signal_connect (GTK_OBJECT (button13), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button13_clicked),
                      NULL);

  sprintf(icondir,"%s/quit.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_printwin.sql_window3, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.\n");
  button14 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Cancel",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_printwin.sql_window3), "button14", button14);
  gtk_widget_show (button14);
  gtk_container_border_width (GTK_CONTAINER (button14), 6);
  gtk_signal_connect (GTK_OBJECT (button14), "clicked",
                   GTK_SIGNAL_FUNC (sql_on_button14_clicked),
                      NULL);

  return sql_printwin.sql_window3;
}

