/*
 * Copyright ? Matthew Chappee <matthew@orasoft.org>
 *             Paul Flinders <paul@orasoft.org>
 *             Brent Gilmore <brent@orasoft.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>

void sql_on_Add_Bookmark_activate (GtkMenuItem     *menuitem,gpointer         user_data);
void sql_on_Edit_Bookmark_activate (GtkMenuItem     *menuitem,gpointer         user_data);			
void sql_on_Open_activate             (GtkMenuItem *menuitem,gpointer user_data);
void sql_on_Save_Query_activate       (GtkMenuItem *menuitem,gpointer user_data);
void sql_on_Save_Query_As_activate    (GtkMenuItem *menuitem,gpointer user_data);
void sql_on_Quit_activate             (GtkMenuItem *menuitem,gpointer user_data);
void sql_on_Save_Connection_activate  (GtkMenuItem *menuitem,gpointer user_data);
void sql_on_Forget_Connection_activate(GtkMenuItem     *menuitem,gpointer         user_data);
void sql_on_Change_Connection_activate(GtkMenuItem     *menuitem,gpointer         user_data);
void sql_on_Change_Delimiter_activate (GtkMenuItem     *menuitem,gpointer         user_data);					
void sql_on_Change_Max_Buffer_activate(GtkMenuItem     *menuitem,gpointer         user_data);					
void sql_on_Sqlwork_activate          (GtkMenuItem     *menuitem,gpointer         user_data);
gboolean sql_on_text5_button_press_event (GtkWidget       *widget,GdkEventButton  *event,gpointer         user_data);
void sql_on_button1_clicked           (GtkButton       *button,gpointer         user_data);
void sql_on_button2_clicked           (GtkButton       *button,gpointer         user_data);
void sql_on_button3_clicked           (GtkButton       *button,gpointer         user_data);
void sql_on_button4_clicked           (GtkButton       *button,gpointer         user_data);
void sql_on_button5_clicked           (GtkButton       *button,gpointer         user_data);
void sql_on_button7_clicked           (GtkButton       *button,gpointer         user_data);
void sql_on_button8_clicked           (GtkButton       *button,gpointer         user_data);					
void sql_on_button9_clicked           (GtkButton       *button,gpointer         user_data);					
void sql_on_button10_clicked          (GtkButton       *button,gpointer         user_data);
void sql_on_button12_clicked          (GtkButton       *button,gpointer         user_data);
void sql_on_button13_clicked          (GtkButton       *button,gpointer         user_data);
void sql_on_button14_clicked          (GtkButton       *button,gpointer         user_data);
void sql_on_button15_clicked          (GtkButton       *button,gpointer         user_data);					
void sql_on_button16_clicked          (GtkButton       *button,gpointer         user_data);					
void sql_on_button17_clicked          (GtkButton       *button,gpointer         user_data);
void sql_on_button18a_clicked         (GtkButton       *button,gpointer         user_data);					
void sql_on_button18b_clicked         (GtkButton       *button,gpointer         user_data);	
void sql_on_button19_clicked         (GtkButton       *button,gpointer         user_data);	
gboolean sql_on_label6_focus_in_event (GtkWidget       *widget,GdkEventFocus   *event,gpointer         user_data);
gboolean sql_on_label7_focus_in_event (GtkWidget       *widget,GdkEventFocus   *event,gpointer         user_data);					
void sql_on_clist3_select_row         (GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data);					
void sql_on_Discovery_activate        (GtkMenuItem     *menuitem,gpointer         user_data);
void sql_on_About_SQLWork_activate    (GtkMenuItem     *menuitem,gpointer         user_data);
void sql_on_About_OraLinux_activate   (GtkMenuItem     *menuitem,gpointer         user_data);					
void sql_destroy_about                (GtkButton       *button,gpointer         user_data);		
void sql_file_ok_sel                  (GtkWidget *w, GtkFileSelection *fs);
void sql_file_ok_save                 (GtkWidget *w, GtkFileSelection *fs);
void sql_file_ok_export               (GtkWidget *w, GtkFileSelection *fs);
void sql_file_cancel_sel              (GtkWidget *w, GtkFileSelection *fs);
void sql_destroy                      (GtkWidget *widget,gpointer   data );
void sql_on_list1_selection_changed   (GtkList         *list,gpointer         user_data);
gboolean sql_on_list1_focus_out_event (GtkWidget       *widget,GdkEventFocus   *event,gpointer         user_data);
void sql_on_clist2_draw  (GtkWidget       *widget,GdkRectangle    *area,gpointer         user_data);
void sql_rebuildclist(void);
void sql_on_text4_draw  (GtkWidget       *widget,GdkRectangle    *area,gpointer         user_data);
gboolean sql_on_window1_key_press_event (GtkWidget *widget,GdkEventKey *event,gpointer user_data);
gboolean sql_on_login_key_press_event (GtkWidget *widget,GdkEventKey *event,gpointer user_data);
int sql_getobjtype(char *owner,char *objname, char *dblink);
void sql_describetable(char *owner,char *tablename,char *dblink);
void sql_showtext(char *distext);
int sql_viewtable(void);
int sql_getsessionid(void);
void sql_showsql(void);

void do_regfile(char *regfile);

typedef struct sql_clistinfo_str{
  int numrows;
  int numcols;
}sql_clistinfo;

sql_clistinfo sql_cinfo;

typedef struct sql_globalinfo_str{
  char *globallogin;
  char globaldelim[255];
  char globalbuffer[255];
  int globalbreak;
  gchar *filename;
  gint crow;
  int globalprint;
  int totaldisc;
  char regfile[255];
  char iconpath[500];
  int fastmode;
  char *sqlhistory[20];
  int totalhistory;
  int doingquery;
  int historypointer;
  int freemem;
}sql_globalinfo;

sql_globalinfo sql_ginfo;

GtkWidget* sql_create_login (void);
int sql_do_post_login(void);

char *sse(char *);
char *ssb(char *); 
char *nosemi(char *);
char *strupr(char *);
char *nocrlfe(char *);
char *nocrlfb(char *);

int sql_alloc_descriptors(int, int, int);
int sql_get_dyn_statement(void);
void sql_set_bind_variables(void);
void sql_process_select_list(void);
void sql_sql_error(void);
void sql_clear_text(int);
void sql_openfile(int);
void sql_savefile(int);
void sql_printproc();
void sql_saveconnection(int);
void sql_discovery(void);
char *rc_getval(char*,char *);
void sql_initglobals(void);
			
