/*
 * Copyright ? Matthew Chappee <matthew@orasoft.org>
 *             Paul Flinders <paul@orasoft.org>
 *             Brent Gilmore <brent@orasoft.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "sqlworksig.h"
#include "sqlworksrc.h"

GtkWidget*
sql_create_window1 ()
{
  GtkWidget *vbox1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkWidget *button3;
  GtkWidget *button4;
  GtkWidget *button5;
  GtkWidget *button9;
  GtkWidget *vseparator1;
  GtkWidget *button7;
  GtkWidget *button8;
  GtkWidget *hbox1;
  GtkWidget *hbox3;
  GtkWidget *vbox3;
  GtkWidget *label11;
  GtkWidget *label12;
  GtkWidget *label13;
  GtkWidget *label14;
  GtkWidget *label15;
  GtkWidget *vscroll;           /* SQL Buffer Scroll Bar */
  char *homedir,icondir[255];

  homedir=getenv("HOME");

  sql_mainwin.sql_window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_window1", sql_mainwin.sql_window1);
  gtk_window_set_title (GTK_WINDOW (sql_mainwin.sql_window1), "SqlWork");
  gtk_window_set_policy (GTK_WINDOW (sql_mainwin.sql_window1), TRUE, TRUE, FALSE);
  gtk_signal_connect (GTK_OBJECT (sql_mainwin.sql_window1), "destroy",
                      GTK_SIGNAL_FUNC (sql_destroy), NULL);
  gtk_signal_connect (GTK_OBJECT (sql_mainwin.sql_window1), "key_press_event",
                      GTK_SIGNAL_FUNC (sql_on_window1_key_press_event),
                      NULL);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "vbox1", vbox1);
  gtk_widget_set_usize (vbox1, 800, 600);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (sql_mainwin.sql_window1), vbox1);

  sql_mainwin.sql_menubar1 = gtk_menu_bar_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_menubar1", sql_mainwin.sql_menubar1);
  gtk_widget_show (sql_mainwin.sql_menubar1);
  gtk_box_pack_start (GTK_BOX (vbox1), sql_mainwin.sql_menubar1, FALSE, TRUE, 0);

  sql_mainwin.sql_toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_toolbar1", sql_mainwin.sql_toolbar1);
  gtk_toolbar_set_button_relief(GTK_TOOLBAR(sql_mainwin.sql_toolbar1), GTK_RELIEF_NONE);
  gtk_widget_show (sql_mainwin.sql_toolbar1);
  gtk_box_pack_start (GTK_BOX (vbox1), sql_mainwin.sql_toolbar1, FALSE, TRUE, 0);

  sprintf(icondir,"%s/new.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_mainwin.sql_window1, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");
  button1 = gtk_toolbar_append_element (GTK_TOOLBAR (sql_mainwin.sql_toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "New\nQuery",
                                "New Query\nHotkey F1", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "button1", button1);
  gtk_widget_show (button1);
  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button1_clicked),
                      NULL);

  sprintf(icondir,"%s/open.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_mainwin.sql_window1, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");
  button2 = gtk_toolbar_append_element (GTK_TOOLBAR (sql_mainwin.sql_toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Open\nQuery",
                                "Open Query\nHotkey F2", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "button2", button2);
  gtk_widget_show (button2);
  gtk_signal_connect (GTK_OBJECT (button2), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button2_clicked),
                      NULL);

  sprintf(icondir,"%s/save.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_mainwin.sql_window1, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");
  button3 = gtk_toolbar_append_element (GTK_TOOLBAR (sql_mainwin.sql_toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Save\nQuery",
                                "Save Query\nHotkey F3", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "button3", button3);
  gtk_widget_show (button3);
  gtk_signal_connect (GTK_OBJECT (button3), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button3_clicked),
                      NULL);

  sprintf(icondir,"%s/print.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_mainwin.sql_window1, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");
  button4 = gtk_toolbar_append_element (GTK_TOOLBAR (sql_mainwin.sql_toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Print\nQuery",
                                "Print Query\nHotkey F4", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "button4", button4);
  gtk_widget_show (button4);
  gtk_signal_connect (GTK_OBJECT (button4), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button4_clicked),
                      NULL);

  sprintf(icondir,"%s/quit.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_mainwin.sql_window1, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");
  button5 = gtk_toolbar_append_element (GTK_TOOLBAR (sql_mainwin.sql_toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "\nQuit",
                                "Quit\nHotkey F10", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "button5", button5);
  gtk_widget_show (button5);
  gtk_signal_connect (GTK_OBJECT (button5), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button5_clicked),
                      NULL);

  sprintf(icondir,"%s/submit.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_mainwin.sql_window1, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");
  button9 = gtk_toolbar_append_element (GTK_TOOLBAR (sql_mainwin.sql_toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "\nExecute",
                                "Execute\nHotkey F6", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "button9", button5);
  gtk_widget_show (button9);
  gtk_signal_connect (GTK_OBJECT (button9), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button9_clicked),
                      NULL);


  vseparator1 = gtk_vseparator_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "vseparator1", vseparator1);
  gtk_widget_set_usize (vseparator1, 30, 30);
  gtk_widget_show (vseparator1);
  gtk_toolbar_append_widget (GTK_TOOLBAR (sql_mainwin.sql_toolbar1), vseparator1, NULL, NULL);


  sprintf(icondir,"%s/print.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_mainwin.sql_window1, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");
  button7 = gtk_toolbar_append_element (GTK_TOOLBAR (sql_mainwin.sql_toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Print\nOutput",
                                "Print Output\nHotkey F7", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "button7", button7);
  gtk_widget_show (button7);
  gtk_signal_connect (GTK_OBJECT (button7), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button7_clicked),
                      NULL);

  sprintf(icondir,"%s/save.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_mainwin.sql_window1, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");
  button8 = gtk_toolbar_append_element (GTK_TOOLBAR (sql_mainwin.sql_toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Export\nOutput",
                                "Export Output\nHotkey F8", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "button8", button8);
  gtk_widget_show (button8);
  gtk_signal_connect (GTK_OBJECT (button8), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button8_clicked),
                      NULL);

  sql_mainwin.sql_vseparator2 = gtk_vseparator_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_vseparator2", sql_mainwin.sql_vseparator2);
  gtk_widget_set_usize (sql_mainwin.sql_vseparator2, 10, 30);
  gtk_toolbar_append_widget (GTK_TOOLBAR (sql_mainwin.sql_toolbar1), sql_mainwin.sql_vseparator2, NULL, NULL);

  sql_mainwin.sql_progressbar1 = gtk_progress_bar_new ();
  gtk_widget_ref (sql_mainwin.sql_progressbar1);
  gtk_object_set_data_full (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_progressbar1", sql_mainwin.sql_progressbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_progress_bar_set_bar_style (GTK_PROGRESS_BAR (sql_mainwin.sql_progressbar1),GTK_PROGRESS_CONTINUOUS);  
  gtk_toolbar_append_widget (GTK_TOOLBAR (sql_mainwin.sql_toolbar1), sql_mainwin.sql_progressbar1, NULL, NULL);

  sql_mainwin.sql_vseparator3 = gtk_vseparator_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_vseparator3", sql_mainwin.sql_vseparator3);
  gtk_widget_set_usize (sql_mainwin.sql_vseparator3, 10, 30);
  gtk_toolbar_append_widget (GTK_TOOLBAR (sql_mainwin.sql_toolbar1), sql_mainwin.sql_vseparator3, NULL, NULL);

  sprintf(icondir,"%s/stop.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_mainwin.sql_window1, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");
  sql_mainwin.sql_button10 = gtk_toolbar_append_element (GTK_TOOLBAR (sql_mainwin.sql_toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "\nStop",
                                "Stop Query", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_button10", sql_mainwin.sql_button10);
  gtk_widget_hide (sql_mainwin.sql_button10);
  gtk_signal_connect (GTK_OBJECT (sql_mainwin.sql_button10), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button10_clicked),
                      NULL);

  sprintf(icondir,"%s/submit.xpm",sql_ginfo.iconpath);

  tmp_toolbar_icon = sql_create_pixmap (sql_mainwin.sql_window1, icondir);
  if (tmp_toolbar_icon == NULL)
    printf ("\nCould not create pixmap, run 'make install' to create pixmaps and reg files.");
  sql_mainwin.sql_button19 = gtk_toolbar_append_element (GTK_TOOLBAR (sql_mainwin.sql_toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Fast\nMode",
                                "Fast Mode", NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_button19", sql_mainwin.sql_button19);
  gtk_widget_hide (sql_mainwin.sql_button19);
  gtk_signal_connect (GTK_OBJECT (sql_mainwin.sql_button19), "clicked",
                      GTK_SIGNAL_FUNC (sql_on_button19_clicked),
                      NULL);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "hbox1", hbox1);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "vbox3", vbox3);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox3, TRUE, TRUE, 0);

  sql_mainwin.sql_hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_hbox2", sql_mainwin.sql_hbox2);
  gtk_widget_show (sql_mainwin.sql_hbox2);
  gtk_box_pack_start (GTK_BOX (vbox3), sql_mainwin.sql_hbox2, TRUE, TRUE, 0);

  sql_mainwin.sql_notebook2 = gtk_notebook_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_notebook2", sql_mainwin.sql_notebook2);
  gtk_widget_set_usize (sql_mainwin.sql_notebook2, 800, 400);
  gtk_widget_show (sql_mainwin.sql_notebook2);
  gtk_box_pack_start (GTK_BOX (sql_mainwin.sql_hbox2), sql_mainwin.sql_notebook2, TRUE, TRUE, 0);

  sql_mainwin.sql_scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_scrolledwindow1", sql_mainwin.sql_scrolledwindow1);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sql_mainwin.sql_scrolledwindow1),
                                           GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (sql_mainwin.sql_scrolledwindow1);
  gtk_container_add (GTK_CONTAINER (sql_mainwin.sql_notebook2), sql_mainwin.sql_scrolledwindow1);

  sql_mainwin.sql_text4 = gtk_text_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_text4", sql_mainwin.sql_text4);
  gtk_text_set_word_wrap (GTK_TEXT(sql_mainwin.sql_text4),FALSE);
  gtk_text_set_line_wrap (GTK_TEXT(sql_mainwin.sql_text4),FALSE);
  gtk_widget_show (sql_mainwin.sql_text4);
  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (sql_mainwin.sql_scrolledwindow1), sql_mainwin.sql_text4);
  gtk_signal_connect (GTK_OBJECT (sql_mainwin.sql_text4), "draw",
                      GTK_SIGNAL_FUNC (sql_on_text4_draw),
                      NULL);

  sql_mainwin.sql_vscrollbar1 = gtk_vscrollbar_new (GTK_TEXT (sql_mainwin.sql_text4)->vadj);
  gtk_box_pack_start (GTK_BOX (sql_mainwin.sql_hbox2), sql_mainwin.sql_vscrollbar1, FALSE,FALSE, 0);
  gtk_widget_show (sql_mainwin.sql_vscrollbar1);
    
  sql_mainwin.sql_scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_scrolledwindow2", sql_mainwin.sql_scrolledwindow2);
  gtk_widget_show (sql_mainwin.sql_scrolledwindow2);
  gtk_container_add (GTK_CONTAINER (sql_mainwin.sql_notebook2), sql_mainwin.sql_scrolledwindow2);

  sql_mainwin.sql_clist2 = gtk_clist_new (3);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_clist2", sql_mainwin.sql_clist2);
  gtk_widget_show (sql_mainwin.sql_clist2);
  gtk_container_add (GTK_CONTAINER (sql_mainwin.sql_scrolledwindow2), sql_mainwin.sql_clist2);
  gtk_clist_set_column_width (GTK_CLIST (sql_mainwin.sql_clist2), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (sql_mainwin.sql_clist2), 1, 80);
  gtk_clist_set_column_width (GTK_CLIST (sql_mainwin.sql_clist2), 2, 80);
  gtk_clist_column_titles_show (GTK_CLIST (sql_mainwin.sql_clist2));
  gtk_widget_add_events(sql_mainwin.sql_clist2, GDK_ALL_EVENTS_MASK);
  gtk_signal_connect (GTK_OBJECT (sql_mainwin.sql_clist2), "draw",
                      GTK_SIGNAL_FUNC (sql_on_clist2_draw),
                      NULL);
		      
  label11 = gtk_label_new ("Text View");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "label11", label11);
  gtk_widget_show (label11);
  sql_set_notebook_tab (sql_mainwin.sql_notebook2, 0, label11);

  label12 = gtk_label_new ("Grid View");
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "label12", label12);
  gtk_widget_show (label12);
  sql_set_notebook_tab (sql_mainwin.sql_notebook2, 1, label12);

  /* SQL Buffer */

  sql_mainwin.sql_hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_hbox3", sql_mainwin.sql_hbox3);
  gtk_widget_show (sql_mainwin.sql_hbox3);
  gtk_box_pack_start (GTK_BOX (vbox3), sql_mainwin.sql_hbox3, TRUE, TRUE, 0);

  sql_mainwin.sql_text5 = gtk_text_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_text5", sql_mainwin.sql_text5);

  gtk_widget_show (sql_mainwin.sql_text5);
 
  vscroll = gtk_vscrollbar_new (GTK_TEXT (sql_mainwin.sql_text5)->vadj);
  gtk_widget_show (vscroll);

  gtk_box_pack_start (GTK_BOX (sql_mainwin.sql_hbox3), sql_mainwin.sql_text5, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (sql_mainwin.sql_hbox3), vscroll,  FALSE, FALSE, 0);

  gtk_text_set_editable (GTK_TEXT (sql_mainwin.sql_text5), TRUE);
  gtk_signal_connect_after (GTK_OBJECT (sql_mainwin.sql_text5), "button_release_event",
                      GTK_SIGNAL_FUNC (sql_on_text5_button_press_event),
                      NULL);

  /* End SQL Buffer, Begin Status Bar */

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "hbox3", hbox3);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox3),hbox3, TRUE, TRUE, 0);

  sql_mainwin.sql_statusbar1 = gtk_statusbar_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_statusbar1", sql_mainwin.sql_statusbar1);
  gtk_widget_set_usize (sql_mainwin.sql_statusbar1, 220, 45);
  gtk_widget_show (sql_mainwin.sql_statusbar1);
  gtk_box_pack_start (GTK_BOX (hbox3), sql_mainwin.sql_statusbar1, TRUE, TRUE, 0);
  
  sql_mainwin.sql_statusbar2 = gtk_statusbar_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_statusbar2", sql_mainwin.sql_statusbar2);
  gtk_widget_set_usize (sql_mainwin.sql_statusbar2, 220, 45);
  gtk_widget_show (sql_mainwin.sql_statusbar2);
  gtk_box_pack_start (GTK_BOX (hbox3), sql_mainwin.sql_statusbar2, TRUE, TRUE, 0);
  
  sql_mainwin.sql_statusbar3 = gtk_statusbar_new ();
  gtk_object_set_data (GTK_OBJECT (sql_mainwin.sql_window1), "sql_mainwin.sql_statusbar3", sql_mainwin.sql_statusbar3);
  gtk_widget_set_usize (sql_mainwin.sql_statusbar3, 360, 45);
  gtk_widget_show (sql_mainwin.sql_statusbar3);
  gtk_box_pack_start (GTK_BOX (hbox3), sql_mainwin.sql_statusbar3, TRUE, TRUE, 0);

  gtk_statusbar_push( GTK_STATUSBAR(sql_mainwin.sql_statusbar3),
      gtk_statusbar_get_context_id(GTK_STATUSBAR(sql_mainwin.sql_statusbar3), ""), "Sqlwork v3.0");

  sql_create_menu();

  return sql_mainwin.sql_window1;
}

void
sql_create_fileselection ()
{
    sql_filew = gtk_file_selection_new ("File selection");
    gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(sql_filew));
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (sql_filew)->ok_button),
                        "clicked", (GtkSignalFunc) sql_file_ok_sel, sql_filew );
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (sql_filew)->cancel_button),
                               "clicked", (GtkSignalFunc) sql_file_cancel_sel,
                               GTK_OBJECT (sql_filew));
}              

void
sql_create_filesave (int a)
{
  if(a){
    sql_filesave = gtk_file_selection_new ("File Save");
    gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(sql_filesave));
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (sql_filesave)->ok_button),
                        "clicked", (GtkSignalFunc) sql_file_ok_save, sql_filesave );
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (sql_filesave)->cancel_button),
                               "clicked", (GtkSignalFunc) sql_file_cancel_sel,
                               GTK_OBJECT (sql_filesave));
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(sql_filesave),
                                     "statement.sql");
  }else{
    sql_filesave = gtk_file_selection_new ("File Save");
    gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(sql_filesave));
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (sql_filesave)->ok_button),
                        "clicked", (GtkSignalFunc) sql_file_ok_export, sql_filesave );
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (sql_filesave)->cancel_button),
                               "clicked", (GtkSignalFunc) sql_file_cancel_sel,
                               GTK_OBJECT (sql_filesave));
    
    
  }
																     				     
}

