/*
 * Copyright ? Matthew Chappee <matthew@orasoft.org>
 *             Paul Flinders <paul@orasoft.org>
 *             Brent Gilmore <brent@orasoft.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>

GtkWidget* sql_get_widget    (GtkWidget       *widget,gchar           *widget_name);
void sql_set_notebook_tab    (GtkWidget       *notebook,gint             page_num,GtkWidget       *widget);
void sql_add_pixmap_directory(gchar           *directory);
GtkWidget* sql_create_pixmap (GtkWidget       *widget,gchar           *filename);

typedef struct sql_mainwin_str{
  GtkWidget *sql_window1;
  GtkWidget *sql_text4;
  GtkWidget *sql_text5;
  GtkWidget *sql_clist2;
  GtkWidget *sql_notebook2;
  GtkWidget *sql_scrolledwindow1;
  GtkWidget *sql_scrolledwindow2;
  GtkWidget *sql_clistlabel[1000];
  GtkWidget *sql_menubar1;
  GtkWidget *sql_hbox2;
  GtkWidget *sql_vscrollbar1;
  GtkWidget *sql_Text;
  GtkWidget *sql_progressbar1;
  GtkWidget *sql_button10;
  GtkWidget *sql_button19;
  GtkWidget *sql_vseparator2;
  GtkWidget *sql_vseparator3;  
  GtkWidget *sql_statusbar1;
  GtkWidget *sql_statusbar2;
  GtkWidget *sql_statusbar3;
  GtkWidget *sql_toolbar1;
  GtkWidget *sql_hbox3;             /* Contains the SQL Buffer */
  GtkAccelGroup *sql_accel_group;
}sql_mainwin_struct;

typedef struct sql_loginwin_str{
  GtkWidget *sql_login;
  GtkWidget *sql_username_entry;
  GtkWidget *sql_password_entry;
  GtkWidget *sql_tns_entry;
  GtkWidget *sql_login_cancel;
  GtkWidget *sql_login_ok;
}sql_loginwin_struct;
  
typedef struct sql_printwin_str{
  GtkWidget *sql_window3;
  GtkWidget *sql_entry1;
  GtkWidget *sql_entry2;
}sql_printwin_struct;
  
typedef struct sql_aboutwin_str{
  GtkWidget *sql_aboutbox;
  GtkWidget *sql_text3;
}sql_aboutwin_struct;
  
typedef struct sql_configwin_str{
  GtkWidget *sql_window5;
  GtkWidget *sql_entry10;
}sql_configwin_struct;
  
typedef struct sql_exportwin_str{
  GtkWidget *sql_window4;
  GtkWidget *sql_clist3;
}sql_exportwin_struct;
  
sql_mainwin_struct sql_mainwin;
sql_loginwin_struct sql_loginwin;
sql_printwin_struct sql_printwin;
sql_aboutwin_struct sql_aboutwin;
sql_configwin_struct sql_configwin;
sql_exportwin_struct sql_exportwin;

GtkWidget *sql_filesave;
GtkWidget *sql_filew;  

/* New Login Stuff */
gboolean sql_on_login_key_press_event (GtkWidget *widget,GdkEventKey *event,gpointer user_data);
void sql_on_login_cancel_clicked          (GtkButton       *button,gpointer         user_data);
void sql_on_login_ok_clicked          (GtkButton       *button,gpointer         user_data);

/* Toolbar Menu Stuff */
void sql_on_text1_activate (GtkMenuItem     *menuitem,gpointer         user_data);
void sql_on_icons1_activate (GtkMenuItem     *menuitem,gpointer         user_data);
void sql_on_text_and_icons1_activate (GtkMenuItem     *menuitem,gpointer         user_data);

GtkWidget* sql_create_aboutbox (void);
GtkWidget* sql_create_window1 (void);
GtkWidget* sql_create_window3 (void);
GtkWidget* sql_create_window4 (void);
GtkWidget* sql_create_window6 (void);
GtkWidget* sql_create_confirm (void);
void sql_create_fileselection (void);
void sql_create_filesave (int);
void sql_create_menu(void);
  
typedef struct sql_disc_str{
  char *dname;
  char *path;
  char *icon;
}sql_discstruct;

sql_discstruct sql_disc[20];


